import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

public class ROT13  {
    protected int shift;

    ROT13(Character cs, Character cf) {
        this.shift = cf - cs;
    }

    ROT13() {
        this.shift = 13;
    }

    ROT13(int shift) {
        this.shift = shift;
    }

    public String crypt(String text) throws UnsupportedOperationException {
        char[] arrayToEncrypt = text.toCharArray();
            for (int i = 0; i < arrayToEncrypt.length; i++) {
                if (Character.isLowerCase(arrayToEncrypt[i])) {
                    arrayToEncrypt[i] = (char) (((int) arrayToEncrypt[i] + shift - (int) 'a') % 26 + (int) 'a');
                } else if (Character.isUpperCase(arrayToEncrypt[i])) {
                    arrayToEncrypt[i] = (char) (((int) arrayToEncrypt[i] + shift - (int) 'A') % 26 + (int) 'A');
                }
            }
        return String.valueOf(arrayToEncrypt);
    }

    public String encrypt(String text) {
        return crypt(text);
    }

    public String decrypt(String text) {
        shift = 26 - shift;
        return crypt(text);
    }

    public static String rotate(String s, Character c) {
        int n = s.indexOf(c);
        return s.substring(n) + s.substring(0,n);
    }

    public String encryptFile() throws IOException {
        String rawData = new String(Files.readAllBytes(Paths.get("sonnet18.txt")));
        String encryptedData = encrypt(rawData);
        File file = new File("sonnet18.enc");
        FileWriter fileWriter = new FileWriter(file);
        fileWriter.write(encryptedData);
        fileWriter.flush();
        fileWriter.close();
        return encryptedData;
    }

    public String decryptFile() throws IOException {
        String rawData = new String(Files.readAllBytes(Paths.get("sonnet18.enc")));
        return decrypt(rawData);
    }
}