import org.junit.jupiter.api.Test;

import java.io.IOException;

import static org.junit.jupiter.api.Assertions.*;

public class TestCaesar {

    @Test
    public void encryptTest1() {
        // Given
        Caesar caesar = new Caesar('A', 'X');

        String Q1 = "ABCDEFGHIJKLMNOPQRSTUVWXYZj";
        String A1 = "XYZABCDEFGHIJKLMNOPQRSTUVWg";

        // When
        String actual = caesar.encrypt(Q1);

        // Then
        assertEquals(A1, actual);
    }

    @Test
    public void encryptTest2() {
        // Given
        Caesar caesar = new Caesar('a', 'b');

        String Q1 = "!defend the east wall of the castle?";
        String A1 = "!efgfoe uif fbtu xbmm pg uif dbtumf?";

        // When
        String actual = caesar.encrypt(Q1);

        // Then
        assertEquals(A1, actual);
    }

    @Test
    public void encryptTest3() {
        // Given
        Caesar caesar = new Caesar('a', 'x');

        String Q1 = "QEB NRFZH YOLTK CLU GRJMP LSBO QEB IXWV ALD";
        String A1 = "THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG";

        // When
        String actual = caesar.encrypt(A1);

        // Then
        assertEquals(Q1, actual);
    }

    @Test
    public void decryptTest1() {
        // Given
        Caesar caesar = new Caesar('A', 'X');

        String Q1 = "ABCDEFGHIJKLMNOPQRSTUVWXYZj";
        String A1 = "XYZABCDEFGHIJKLMNOPQRSTUVWg";

        // When
        String actual = caesar.decrypt(A1);

        // Then
        assertEquals(Q1, actual);
    }

    @Test
    public void decryptTest2() {
        // Given
        Caesar caesar = new Caesar('a', 'x');

        String Q1 = "QEB NRFZH YOLTK CLU GRJMP LSBO QEB IXWV ALD";
        String A1 = "THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG";

        // When
        String actual = caesar.decrypt(Q1);

        // Then
        assertEquals(A1, actual);
    }

    @Test
    public void cryptTest2() {
        // Given
        Caesar cipher = new Caesar('h', 'm');
        String Q1 = "Why did the chicken cross the road?";
        // When
        String actual = cipher.decrypt(cipher.encrypt(cipher.decrypt(cipher.encrypt(Q1))));
        // Then
        assertTrue(actual.equals(Q1));
    }

    @Test
    public void testEncryptFile() throws IOException {
        // Given
        Caesar cipher = new Caesar('a', 'f');
        String Q1 = "Xmfqq N htrufwj ymjj yt f xzrrjw’x ifd?\n" +
                "Ymtz fwy rtwj qtajqd fsi rtwj yjrujwfyj:\n" +
                "Wtzlm bnsix it xmfpj ymj ifwqnsl gzix tk Rfd,\n" +
                "Fsi xzrrjw’x qjfxj mfym fqq ytt xmtwy f ifyj;\n" +
                "Xtrjynrj ytt mty ymj jdj tk mjfajs xmnsjx,\n" +
                "Fsi tkyjs nx mnx ltqi htruqjcnts inrr'i;\n" +
                "Fsi jajwd kfnw kwtr kfnw xtrjynrj ijhqnsjx,\n" +
                "Gd hmfshj tw sfyzwj’x hmfslnsl htzwxj zsywnrr'i;\n" +
                "Gzy ymd jyjwsfq xzrrjw xmfqq sty kfij,\n" +
                "Stw qtxj utxxjxxnts tk ymfy kfnw ymtz tb’xy;\n" +
                "Stw xmfqq ijfym gwfl ymtz bfsijw’xy ns mnx xmfij,\n" +
                "Bmjs ns jyjwsfq qnsjx yt ynrj ymtz lwtb’xy:\n" +
                "   Xt qtsl fx rjs hfs gwjfymj tw jdjx hfs xjj,\n" +
                "   Xt qtsl qnajx ymnx, fsi ymnx lnajx qnkj yt ymjj.\n";
        // When
        String actual = cipher.encryptFile();
        // Then
        assertTrue(actual.equals(Q1));
    }

    @Test
    public void testDecryptFile() throws IOException {
        // Given
        Caesar cipher = new Caesar('b', 'g');
        String Q1 = "Shall I compare thee to a summer’s day?\n" +
                "Thou art more lovely and more temperate:\n" +
                "Rough winds do shake the darling buds of May,\n" +
                "And summer’s lease hath all too short a date;\n" +
                "Sometime too hot the eye of heaven shines,\n" +
                "And often is his gold complexion dimm'd;\n" +
                "And every fair from fair sometime declines,\n" +
                "By chance or nature’s changing course untrimm'd;\n" +
                "But thy eternal summer shall not fade,\n" +
                "Nor lose possession of that fair thou ow’st;\n" +
                "Nor shall death brag thou wander’st in his shade,\n" +
                "When in eternal lines to time thou grow’st:\n" +
                "   So long as men can breathe or eyes can see,\n" +
                "   So long lives this, and this gives life to thee.\n";
        // When
        String actual = cipher.decryptFile();
        // Then
        assertEquals(Q1, actual);
    }
}